package com.example.testgrid.widgetset.client;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import com.google.gwt.core.shared.GWT;
import com.google.gwt.event.logical.shared.ValueChangeEvent;
import com.google.gwt.event.logical.shared.ValueChangeHandler;
import com.google.gwt.event.shared.HandlerManager;
import com.google.gwt.user.client.ui.TextBox;
import com.vaadin.client.renderers.WidgetRenderer;
import com.vaadin.client.widget.grid.RendererCellReference;

public class TextFieldRenderer extends WidgetRenderer<String, TextBox> {

	@Override
	public TextBox createWidget() {
		 TextBox txt = GWT.create(TextBox.class);
		 txt.setStylePrimaryName("v-textfield");
	     return txt;
	}

	@Override
	public void render(final RendererCellReference cell, String data, TextBox widget) {
		widget.setText(data);
		final int rowindex = cell.getRowIndex();
		widget.addValueChangeHandler(new ValueChangeHandler<String>() {
			
			@Override
			public void onValueChange(ValueChangeEvent<String> event) {
				fireValChange(cell.getColumnIndex()+"", rowindex+"", event.getValue()+"");
			}
		});
	}
	
	public interface ValChangeListener{
		public void valChange(Object propID, Object index, String newValue);
	}
	
	private List<ValChangeListener> listeners = new ArrayList<TextFieldRenderer.ValChangeListener>();
	public void addValChangeListener(ValChangeListener listener){
		listeners.add(listener);
	}
	public void removeValChangeListener(ValChangeListener listener){
		listeners.remove(listener);
	}
	
	public void fireValChange(Object propID, Object index, String newValue){
		for (Iterator it_listener = listeners.iterator(); it_listener.hasNext();) {
			ValChangeListener listener = (ValChangeListener) it_listener.next();
			listener.valChange(propID, index, newValue);
		}
	}

}
