package com.example.testgrid.widgetset.client;

import com.example.testgrid.widgetset.client.TextFieldRenderer.ValChangeListener;
import com.vaadin.client.connectors.AbstractRendererConnector;
import com.vaadin.shared.ui.Connect;

@Connect(com.example.testgrid.TextFieldRenderer.class)
public class TextFieldRendererConnector extends AbstractRendererConnector<String> {
	 @Override
	    public TextFieldRenderer getRenderer() {
	        return (TextFieldRenderer) super.getRenderer();
	    }
	 
	 ValChangeListener listener;
	 @Override
	protected void init() {	
		getRenderer().addValChangeListener(listener = new ValChangeListener() {
			
			@Override
			public void valChange(Object propID, Object index, String newValue) {
				getRpcProxy(TextFieldValChangeRPC.class).valChange(propID+"", index+"", newValue);
			}
		});
		super.init();
	}
	 @Override
	public void onUnregister() {
		 getRenderer().removeValChangeListener(listener);
		super.onUnregister();
	}
}
